-- UpdateInterfaceStatus

DECLARE @@PROCESS_ID NUMERIC(20);
DECLARE @@STATUS INT;
DECLARE @@REFERENCE VARCHAR(40); 
DECLARE @@USERNAME VARCHAR(40); 

SET @@PROCESS_ID = @0;
SET @@STATUS = @1;
SET @@REFERENCE = @2;
SET @@USERNAME = @3;

DECLARE 
    @@INTERFACE_STATUS TABLE( 
	     OTHER_PROCESS_ID NUMERIC(20),
	    [STATUS] NUMERIC(1), -- 0 start 1 finish error 2 in progress 3 finish success 
	    REFERENCE VARCHAR(40), 
	    CREATED_BY VARCHAR(20),
	    CREATED_DT DATETIME);

DECLARE @@sql VARCHAR(MAX);
SET @@sql = 'SELECT * FROM OPENQUERY(IPPCS_TO_ICS, ' 
   + '''SELECT OTHER_PROCESS_ID, STATUS, REFERENCE ' 
   + ' FROM TB_R_PCS_INTERFACE_STATUS ' 
   + ' WHERE OTHER_PROCESS_ID = ' + CONVERT(VARCHAR(20), @@PROCESS_ID) + ''')';
   
INSERT INTO @@INTERFACE_STATUS (OTHER_PROCESS_ID, [STATUS], REFERENCE)
EXEC(@@SQL); 

IF NOT EXISTS(SELECT * FROM @@INTERFACE_STATUS) 
BEGIN
	INSERT INTO @@INTERFACE_STATUS VALUES(
		@@PROCESS_ID, 
		@@STATUS, 
		@@REFERENCE, 
		@@USERNAME, 
		GETDATE());
		
	INSERT OPENQUERY(IPPCS_TO_ICS, 
		'SELECT OTHER_PROCESS_ID, STATUS, REFERENCE, CREATED_BY, CREATED_DT FROM TB_R_PCS_INTERFACE_STATUS')
	SELECT OTHER_PROCESS_ID, STATUS, REFERENCE, CREATED_BY, CREATED_DT
	FROM @@INTERFACE_STATUS; 
END 
ELSE 
BEGIN
	SET @@SQL = 'UPDATE OPENQUERY(IPPCS_TO_ICS, '  + 
			'''SELECT OTHER_PROCESS_ID, STATUS, REFERENCE ' + 
			 ' FROM TB_R_PCS_INTERFACE_STATUS ' + 
		     ' WHERE OTHER_PROCESS_ID = ' + CONVERT(VARCHAR(20), @@PROCESS_ID) 
		     + ''') SET STATUS = ' +  CONVERT(VARCHAR(1), @@STATUS) + ', REFERENCE = '''
		     + ISNULL(@@REFERENCE,'') + ''';';
	EXEC(@@SQL);
END;

